<?php
/**
 * jtlwawi_Connector/dbeS/syncinclude.php
 * Tools fr Sync
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2006, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.02 / 13.03.07
*/

require_once("../paths.php");

define('ES_ENABLE_LOGGING',0);

// include server parameters
require(DOCROOT_PATH.'admin/includes/configure.php');
// include the list of project database tables
require(DIR_FS_CATALOG.DIR_WS_INCLUDES . 'database_tables.php');
// include the database functions
require(DIR_FS_CATALOG.DIR_WS_FUNCTIONS . 'database.php');
// make a connection to the database... now
tep_db_connect() or ('Kann Datenbankverbindung nicht herstellen! berprfen Sie den DOCROOT_PATH im jtlwawi_Connector/paths.php Script Zeile 15. Der Pfad muss entweder relativ oder absolut auf das Rootverzeichnis Ihres Shops zeigen.');

define ('ES_ATTRIBUTE_AN_BESCHREIBUNG_ANHAENGEN',1);

function eS_execute_query($query)
{	
	return tep_db_query($query);
}

/**
 * Authentifiziert die Anfrage
 *
 * @return Bool true, wenn Auth ok, sonst false
 */
function auth()
{
	$cName = $_POST["userID"];
	$cPass = $_POST["userPWD"];

	$cur_query = eS_execute_query("select * from eazysales_sync");
	$loginDaten = mysql_fetch_object($cur_query);
	if ($cName == $loginDaten->cName && $cPass == $loginDaten->cPass)
		return true;

	return false;
}

/**
 * Gibt einen vardump eines Objekts aus, der sich besser loggen lsst.
 *
 * @param Object $vardump Objekt, das gedumpt werden soll
 * @param int $key Schlssel
 * @param int $level Aktuellw Tiefe
 * @param String $return Rckgabestring
 * @return String verbesserten Vardump
 */
function Dump($vardump)
{
	if (gettype($vardump)!="object" && gettype($vardump)!="array")
		$return.= $vardump;
	elseif (gettype($vardump)=="object")
	{
		foreach(get_object_vars($vardump) as $key => $value)
		{
			$return.= $key." => ".Dump($value).", ";
		}
	}
	elseif (gettype($vardump)=="array")
	{
		foreach ($vardump as $key => $value)
			$return.= $key." => ".Dump($value).", ";
	}
	if ($return{strlen($return)-2}==',')
		return substr($return,0,strlen($return)-2)." ";
	else 
		return $return;
}

/**
 * Fgt Anfhrungszeichen vorne und am Ende an, sobald die Variable nicht leer.
 *
 * @param mixed $value
 * @return $value mit Anfhrungszeichen vorne und hinten. Falls $value leer, werden diese Zeichen nicht hinzugefgt.
 */
function CSVkonform($value)
{
	if (strlen($value)>0)
		return '"'.str_replace('"','""',$value).'"';
}

function datetime2germanDate($datetime)
{
	list ($datum, $uhrzeit) = preg_split(" ",$datetime);
	list ($jahr, $monat, $tag) = preg_split ("-",$datum);
	list ($std, $min, $sec) = preg_split (":",$uhrzeit);
	return $tag.'.'.$monat.'.'.$jahr.' '.$std.':'.$min.':'.$sec;
}

function unhtmlentities($string)
{
   // replace numeric entities
   $string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
   $string = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $string);
   // replace literal entities
   $trans_tbl = get_html_translation_table(HTML_ENTITIES);
   $trans_tbl = array_flip($trans_tbl);
   return strtr($string, $trans_tbl);
}

function setMappingArtikel ($eS_key, $mein_key)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		//ist mein_key schon drin?
		$cur_query = eS_execute_query("select products_id from eazysales_martikel where products_id=".$mein_key);
		$prod = mysql_fetch_object($cur_query);
		if ($prod->products_id>0)
			return "";
		else 
		{
			eS_execute_query("insert into eazysales_martikel (products_id, kArtikel) values ($mein_key,$eS_key)");
		}
	}
}

function setMappingKategorie ($eS_key, $mein_key)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		//ist mein_key schon drin?
		$cur_query = eS_execute_query("select categories_id from eazysales_mkategorie where categories_id=".$mein_key);
		$prod = mysql_fetch_object($cur_query);
		if ($prod->categories_id>0)
			return "";
		else 
		{
			eS_execute_query("insert into eazysales_mkategorie (categories_id, kKategorie) values ($mein_key,$eS_key)");
		}
	}
}

function setMappingEigenschaft ($eS_key, $mein_key, $kArtikel)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key && $kArtikel)
	{
		eS_execute_query("delete from eazysales_mvariation where kEigenschaft=".$eS_key);
		eS_execute_query("insert into eazysales_mvariation (kEigenschaft,products_options_id,kArtikel) values ($eS_key, $mein_key, $kArtikel)");
	}
}

function setMappingBestellPos ($mein_key)
{
	$mein_key = intval($mein_key);
	eS_execute_query("delete from eazysales_mbestellpos where orders_products_id=".$mein_key);
	eS_execute_query("insert into eazysales_mbestellpos (orders_products_id) values ($mein_key)");
	$query = eS_execute_query("select LAST_INSERT_ID()");
	$id_arr = mysql_fetch_row($query);
	return $id_arr[0];
}

function setMappingEigenschaftsWert ($eS_key, $mein_key, $kArtikel)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		logExtra("delete from eazysales_mvariationswert where kEigenschaftsWert=".$eS_key);
		eS_execute_query("delete from eazysales_mvariationswert where kEigenschaftsWert=".$eS_key);
		//ist mein_key schon drin?
		$cur_query = eS_execute_query("select products_attributes_id from eazysales_mvariationswert where kArtikel=$kArtikel and products_attributes_id=".$mein_key);
		logExtra("select products_attributes_id from eazysales_mvariationswert where kArtikel=$kArtikel and products_attributes_id=".$mein_key);
		$prod = mysql_fetch_object($cur_query);
		if ($prod->products_id>0)
			return "";
		else 
		{
			logExtra("insert into eazysales_mvariationswert (products_attributes_id, kEigenschaftsWert, kArtikel) values ($mein_key,$eS_key,$kArtikel)");
			eS_execute_query("insert into eazysales_mvariationswert (products_attributes_id, kEigenschaftsWert, kArtikel) values ($mein_key,$eS_key,$kArtikel)");
		}
	}
}

function getFremdArtikel($eS_key)
{
	$cur_query = eS_execute_query("select products_id from eazysales_martikel where kArtikel=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->products_id;
}

function getEsArtikel($mein_key)
{
	$cur_query = eS_execute_query("select kArtikel from eazysales_martikel where products_id=".$mein_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->kArtikel;
}

function getFremdKategorie($eS_key)
{
	$cur_query = eS_execute_query("select categories_id from eazysales_mkategorie where kKategorie=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->categories_id;
}

function getEsKategorie($mein_key)
{
	$cur_query = eS_execute_query("select kKategorie from eazysales_mkategorie where categories_id=".$mein_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->kKategorie;
}

function getFremdBestellPos($eS_key)
{
	$cur_query = eS_execute_query("select orders_products_id from eazysales_mbestellpos where kBestellPos=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->orders_products_id;
}

function getEsEigenschaft($mein_key, $kArtikel)
{
	$cur_query = eS_execute_query("select kEigenschaft from eazysales_mvariation where kArtikel=".$kArtikel." and products_options_id=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->kEigenschaft;
}

function getFremdEigenschaft($eS_key)
{
	$cur_query = eS_execute_query("select products_options_id from eazysales_mvariation where kEigenschaft=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->products_options_id;
}

function getEigenschaftsArtikel($eS_key)
{
	$cur_query = eS_execute_query("select kArtikel from eazysales_mvariation where kEigenschaft=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->kArtikel;
}

function getFremdEigenschaftsWert($eS_key)
{
	$cur_query = eS_execute_query("select products_attributes_id from eazysales_mvariationswert where kEigenschaftsWert=".$eS_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->products_attributes_id;
}

function getEsEigenschaftsWert($mein_key, $kArtikel)
{
	$cur_query = eS_execute_query("select kEigenschaftsWert from eazysales_mvariationswert where kArtikel=$kArtikel and products_attributes_id=".$mein_key);
	$prod = mysql_fetch_object($cur_query);
	return $prod->kEigenschaftsWert;
}

/**
 * real mysql escape mysql escape
 * @access public
 * @param string $ausdruck Ausdruck, der escaped fr mysql werden soll
 * @return escaped expression
 */
function realEscape ($ausdruck)
{
	if (get_magic_quotes_gpc())
		return mysql_real_escape_string(stripslashes($ausdruck));
	else
		return mysql_real_escape_string($ausdruck);
}

function logExtra($entry)
{
	if (ES_ENABLE_LOGGING!=1)
		return "";
	$logfilename = "logs/".basename($_SERVER['REQUEST_URI'],".php").".log";
	$logfile = fopen($logfilename, 'a');
	fwrite($logfile,"\n[#######Extra Log##########] [".date('m.d.y H:i:s')."]\n".$entry);
	fclose($logfile);
}

function logge($return)
{
	if (ES_ENABLE_LOGGING!=1)
		return "";
	$logfilename = "logs/".basename($_SERVER['REQUEST_URI'],".php").".log";
	$logfile = fopen($logfilename, 'a');
	fwrite($logfile,"\n[".date('m.d.y H:i:s')."] - Ret: $return\n".Dump($_POST));
	fclose($logfile);
}

//get tax 4 product
function get_tax($products_tax_class_id, $tax_zone_id=0)
{
	if (!$tax_zone_id)
	{
		$tax_zone_id= $GLOBALS['einstellungen']->tax_zone_id;
	}
	if (!$products_tax_class_id || !$tax_zone_id)
		return 0;
	//get tax class
	$taxclass_query = eS_execute_query("select * from tax_rates where tax_class_id=".$products_tax_class_id." and tax_zone_id=".$tax_zone_id);
	$tax = mysql_fetch_object($taxclass_query);
	return ($tax->tax_rate);
}

function getSonstigeSprachen($auszuschliessendeLangId)
{
	$langIds = array();
	//hol alle Sprachen
	$cur_query = eS_execute_query("select languages_id from languages");
	while ($res = mysql_fetch_object($cur_query))
	{
		if ($auszuschliessendeLangId!=$res->languages_id)
			array_push($langIds,$res->languages_id);
	}
	return $langIds;
}
?>